# cMonster Class Reference

Inheritance diagram for cMonster:

List of all members.

## Public Member Functions

| cMonster (DWORD dwGUID, DWORD dwMonsterID, cLocation *pcLoc, char *szName, char *szDesc, cMonStats *pcmsStats, DWORD dwRespawn, DWORD dwDecay, DWORD dwChase, DWORD dwInfluence, DWORD dwExp_Value, DWORD dwHealth, DWORD dwStamina, DWORD dwMana)
void | Assess (cClient *pcAssesser)
void | Action (cClient *who)
void | Attack (cClient *who, float flDamageSlider, DWORD F7B0Sequence)
void | SpellAttack (cClient *who, cWarSpell *pcWarSpell, DWORD F7B0Sequence)
cMessage | CreatePacket ()
cMessage | Animation (WORD wAnim, float flPlaySpeed=1.0f)
cMessage | DoDamageMessage (DWORD F7B0seq, std::string target, DWORD damagetype, double severity, DWORD amount)
cMessage | RecieveDamageMessage (DWORD F7B0seq, std::string giver, DWORD damagetype, double severity, DWORD amount, DWORD location)
cMessage | DecrementHealth (DWORD dwGUID, WORD amount, signed int &newhealth)
cMessage | SetHealth (DWORD dwNewHealth)
cMessage | AdjustBar (DWORD dwGUID, DWORD F7B0Sequence)
cMessage | ChangeCombatMode (bool fMode)
cMessage | CombatAnimation (DWORD dwTarget, WORD wAttackAnim)
cMessage | TurnToTarget (float flHeading, DWORD dwTargetGUID)
cMessage | MoveToTarget (cClient *pcWho)
cMessage | MoveTarget (cClient *pcWho)
cMessage | ReturnToSpawn ()
void | ReSpawn (cObject *pcObject)
void | RemoveMonster (cObject *pcObject)
void | MonsterCorpse ()
cMessage | SetPosition ()
DWORD | GetMonsterModelID ()
WORD | GetTotalHealth ()

## Static Public Member Functions

static int | DeathAnimation (LPVOID wp, LPVOID lp)

## Public Attributes

DWORD | m_dwMonsterModelID
WORD | m_wNumMovements
WORD | m_wNumAnimInteracts
WORD | m_wNumBubbleModes
WORD | m_wNumJumps
WORD | m_wNumPortals
WORD | m_wAnimCount
WORD | m_wNumOverrides
WORD | m_wNumLogins
DWORD | m_dwLevel
DWORD | m_dwCurrenthealth
DWORD | m_dwMaxHealth
DWORD | m_dwStr
DWORD | m_dwEnd
DWORD | m_dwQuick
DWORD | m_dwCoord
DWORD | m_dwFocus
DWORD | m_dwSelf
DWORD | m_dwCurrentStamina
DWORD | m_dwCurrentMana
DWORD | m_dwMaxStamina
DWORD | m_dwMaxMana
DWORD | m_dwSpecies
WORD | m_wCurAnim
WORD | m_wMeleeSequence
DWORD | m_dwF7B0Sequence
BYTE | m_bStatSequence
DWORD | m_dwUnknownCount
BYTE | m_bInitialAnimation [200]
BYTE | m_bCombatMode
cLocation | m_TargetLocation
int | m_iPosUpdateCount
bool | m_fHasTarget
DWORD | m_dwTargetGUID

## Friends

class | cClient
class | SimpleAI

## Constructor & Destructor Documentation

cMonster::cMonster | ( | DWORD | dwGUID,
|  | DWORD | dwModelID,
|  | cLocation * | pcLoc,
|  | char * | szName,
|  | char * | szDesc,
|  | cMonStats * | pcmsStats,
|  | DWORD | dwRespawn,
|  | DWORD | dwDecay,
|  | DWORD | dwChase,
|  | DWORD | dwInfluence,
|  | DWORD | dwExp_Value,
|  | DWORD | dwHealth,
|  | DWORD | dwStamina,
|  | DWORD | dwMana |
| ) |  |  |

A constructor.

Called whenever a monster object is initialized.

Handles the creation of monsters.

Called whenever a monster object should be initialized.

Returns:
  cMessage - Returns a Create Object (0x0000F745) server message.

## Member Function Documentation

void cMonster::Action | ( | cClient * | who | ) | `[virtual]`

Handles the actions of monster objects.

This member function is called whenever a monster should perform an action.

Implements cObject.

cMessage cMonster::AdjustBar | ( | DWORD | dwGUID,
|  | DWORD | F7B0Sequence |
| ) |  |  | `[virtual]`

Handles the message sent for the setting of creatures' health bars.

This member function is called when a monster's health should be altered for a client.

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type Update Health (0x000001C0).

Reimplemented from cObject.

void cMonster::Assess | ( | cClient * | pcAssesser | ) | `[virtual]`

Handles the assessment of monster objects.

This member function is called whenever a monster is assessed by a client. Returns a Game Event (0x0000F7B0) server message of type Identify Object (0x000000C9).

Reimplemented from cObject.

void cMonster::Attack | ( | cClient * | who,
|  | float | flDamageSlider,
|  | DWORD | F7B0Sequence |
| ) |  |  | `[virtual]`

Handles functionality for when monster objects are physically attacked.

This member function is called whenever a monster is physically attacked.

Parameters:

  | *who | - A pointer to the client physically attacking the monster.
  | flDamageSlider | - The value of the client's damage slider. F7B0 Sequence - The given client's F7B0 sequence number.

Reimplemented from cObject.

cMessage cMonster::CreatePacket | ( |  | ) | `[virtual]`

Handles the message sent for the creation of monsters.

This member function is called whenever a monster should be created for a client.

Returns:
  cMessage - Returns a Create Object (0x0000F745) server message.

Implements cObject.

int cMonster::DeathAnimation | ( | LPVOID | wp,
|  | LPVOID | lp |
| ) |  |  | `[static]`

Handles the death animation for a killed monster.

cMessage cMonster::DecrementHealth | ( | DWORD | dwGUID,
|  | WORD | amount,
|  | signed int & | newhealth |
| ) |  |  |

Handles the message sent for the updating of creatures' health bars.

This member function is called whenever a monster's health should be updated for a client.

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type Update Health (0x000001C0).

cMessage cMonster::DoDamageMessage | ( | DWORD | F7B0seq,
|  | std::string | target,
|  | DWORD | damagetype,
|  | double | severity,
|  | DWORD | amount |
| ) |  |  |

Handles the message sent for clients' melee attacking of monsters.

This member function is called whenever a client physically attacks a monster.

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type Inflict Melee damage (0x000001B1).

cMessage cMonster::RecieveDamageMessage | ( | DWORD | F7B0seq,
|  | std::string | giver,
|  | DWORD | damagetype,
|  | double | severity,
|  | DWORD | amount,
|  | DWORD | location |
| ) |  |  |

Handles the message sent for the melee attacking of clients by monsters.

This member function is called whenever a client is physically attacked by a monster.

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type Receieve Melee damage (0x000001B2).

void cMonster::ReSpawn | ( | cObject * | pcObject | ) | `[virtual]`

Handles the respawning of monster objects .

This member function is called whenever a monster should be respawned.

Parameters:

  | *pcObject | - A pointer to the monster object to be respawned.

Reimplemented from cObject.

void cMonster::SpellAttack | ( | cClient * | who,
|  | cWarSpell * | pcWarSpell,
|  | DWORD | F7B0Sequence |
| ) |  |  |

Handles functionality for when spells are cast on monster objects.

This member function is called whenever a spell is cast on a monster.

Parameters:

  | *who | - A pointer to the client who cast the spell.
  | *pcWarSpell | - A pointer to the war spell cast by the client.
  | F7B0Sequence | - The given client's F7B0 sequence number.

The documentation for this class was generated from the following files:

- E:/uas2/Server/Object.h
- E:/uas2/Server/Monster.cpp